Index: sys/dev/bge/if_bge.c
===================================================================
--- sys/dev/bge/if_bge.c	(revision 189658)
+++ sys/dev/bge/if_bge.c	(working copy)
@@ -2912,7 +2912,7 @@
 	write_op(sc, BGE_MISC_CFG, BGE_32BITTIME_66MHZ);
 
 	/* Re-enable MSI, if neccesary, and enable the memory arbiter. */
-	if (BGE_IS_5714_FAMILY(sc)) {
+	if (BGE_IS_5714_FAMILY(sc) || sc->bge_flags & BGE_FLAG_MSI) {
 		/* This chip disables MSI on reset. */
 		if (sc->bge_flags & BGE_FLAG_MSI) {
 			val = pci_read_config(dev, BGE_PCI_MSI_CTL, 2);
@@ -2922,8 +2922,10 @@
 			CSR_WRITE_4(sc, BGE_MSI_MODE,
 			    val | BGE_MSIMODE_ENABLE);
 		}
-		val = CSR_READ_4(sc, BGE_MARB_MODE);
-		CSR_WRITE_4(sc, BGE_MARB_MODE, BGE_MARBMODE_ENABLE | val);
+		if (BGE_IS_5714_FAMILY(sc)) {
+			val = CSR_READ_4(sc, BGE_MARB_MODE);
+			CSR_WRITE_4(sc, BGE_MARB_MODE, BGE_MARBMODE_ENABLE | val);
+		}
 	} else
 		CSR_WRITE_4(sc, BGE_MARB_MODE, BGE_MARBMODE_ENABLE);
 

